; :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                             TITLE ListP.asm
; :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

				COMMENT $

This program shows
	 How get a list of a active process on your PC
	 How display this list in a list view child window control
	 How to get the handle of a process from the process ID
	 How to kill a remote process

	New (22/07/2000) :
	 The name: Process Study v0.1
	 How dump a portion of memory to hard disk
	 How display, edit and dump the characteristics of a loaded pe file
	 How load a process

I assume that you have MASM 6.13 at the C:\MASM32 path.
Anyway, is not dificult to do the apropiate changes.

This program is the third part of a process dumper that
I've called VOLKT.


CONTACT: numit_or@subdimension.com
WEB:     http://members.xoom.com/numit_or/asm.html

 n u M I T_o r  [ kUT and Askatasuna Krackers Society ]

				$

; ========================================================================

	.386
	.model flat,stdcall

; ========================================================================

include C:\masm32\include\windows.inc
include C:\masm32\include\kernel32.inc
include C:\masm32\include\user32.inc
include C:\masm32\include\gdi32.inc
include C:\masm32\include\comctl32.inc
include C:\masm32\include\comdlg32.inc
include C:\masm32\include\th32.inc
include pefile.inc 

includelib kernel32.lib
includelib user32.lib
includelib gdi32.lib
includelib comctl32.lib
includelib comdlg32.lib
includelib TH32.lib

; ========================================================================

DlgProc proto :HWND, :UINT, :WPARAM, :LPARAM
ascii2dword proto :DWORD,:DWORD
GetBaseAddressFromPID proto :DWORD

; ========================================================================

; --------------------------------
; Edit sections dialog constants
; --------------------------------
IDE_VSIZE               EQU    1201
IDE_REVAD               EQU    1202
IDE_DS                  EQU    1203
IDE_DO                  EQU    1204
IDE_CHAR                EQU    1205

; ==========================================================================

	.data

Col1	db "Task",0
Col2	db "PID.",0
Col3	db "MID.",0
Col4	db "Threads",0
Col5	db "Parent PID",0

Col6	db "Module",0
Col7	db "Address", 0
Col8	db "Size", 0

szStrTerminate	 db  "&Kill process",0
szStrRefresh	 db  "&Refresh",0
szStrPartialDump db  "Partial &dump", 0
szStrPEInfo      db  "&PE info", 0
szStrHelp	 db  "Help", 0
szStrClose	 db  "E&xit",0

CaptionStr 	db   'Process study, por  n u M I T_o r',0
msg_70          db   'Is not a PE file', 0
msg_71		db   'Problems to identify the process entrty point', 0
msg_72          db   'The process could not be loaded', 0

FilterStr1 	db "Executable files ( *.exe, *.dll, *.ocx)", 0
		db "*.exe; *.dll; *.ocx", 0
		db "All files (*.*)", "*.*", 0, 0

template 	db "%08lX",0
StrDlg		db "TreeDlg",0

HelpFile	db   'PS.HLP', 0
HelpPs		db   'Process Studio: what is', 0

; ==========================================================================

	.data?
pinfo		PROCESS_INFORMATION <>
sui		STARTUPINFO <>

hInst		HINSTANCE ?
hProcess         dd ?

flg_0 		 dd ?
temp_dword       dd ?
hMainWnd         dd ?
oldlistviewproc	 dd ?
@hListView	 dd ?
@pMem		 dd ?
init		 dd ?
ListViewID	 dd ?

buffer 		 db   256 dup (?)
buff2            db    10 dup (?)
szStr   	 db    64 dup (?)

SectHeaderSize   dd ?
pSectHeader      dd ?
ImageBase        dd ?
NumberOfSections dw ?

; ==========================================================================

	.code
entry:
; ---------------------
; Save instance handle
; ---------------------
	invoke	GetModuleHandle,0
        mov	hInst,eax
; ---------------------------
; Start the main dialog 
; ---------------------------
	invoke	DialogBoxParam,hInst,10000,0,addr DlgProc,0
	invoke	ExitProcess,eax
; ---------------------------
; initialize common controls
; ---------------------------
	invoke	InitCommonControls

; :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
; DlgProc procedure
; :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
DlgProc proc uses edi esi ebx hDlg:HWND, msg:UINT, wParam:WPARAM, lParam:LPARAM 
local lppe:PROCESSENTRY32, hSnapshot:DWORD, i:DWORD, hListView:DWORD ;, hProcess:DWORD
local lvcolumn:LV_COLUMN, lvitem:LV_ITEM, pt:POINT, hMenu:DWORD
local ProcessID:DWORD, uCode:DWORD, me32:MODULEENTRY32

; ***************************** WM_INITDIALOG ******************************

	mov	eax,msg
        cmp	eax, WM_INITDIALOG
	jne	o1
; ----------------------------------
; To fill OPENFILENAME struct
; ----------------------------------
	mov	ofn.lStructSize, SIZEOF ofn
	push	hDlg
        pop	ofn.hwndOwner
        push	hInst
        pop	ofn.hInstance
	mov	ofn.Flags, OFN_EXPLORER or OFN_LONGNAMES or OFN_HIDEREADONLY
	mov	ofn.lpstrTitle, 0
	mov	ofn.nMaxFile, 256
; -----------------------------
; Initialize listview controls
; -----------------------------
	push	0
	push	hDlg
	call	RefreshListview
.if init==0
	inc	init
	mov	lvitem.iItem, 0
	mov	lvitem.iSubItem, 0
	mov	lvitem.state, 3
	mov	lvitem.stateMask, 3
	lea	eax, lvitem
	push	eax
	push	0
	push	LVM_SETITEMSTATE
	push	100
	push	hDlg
	call	SendDlgItemMessage
.endif
	jmp	o5	

; ************************** WM_NOTIFY ************************************

o1:	cmp 	eax, WM_NOTIFY
	jne 	o2	
	mov 	eax, lParam
	mov 	ecx, (NM_LISTVIEW ptr [eax]).hdr.code
	mov	edx, (NM_LISTVIEW ptr [eax]).hdr.idFrom
	.if cx==NM_RCLICK && (edx==100 || edx==101)
		; ----------------------------
		; Get the selected item state
		; ----------------------------
		mov	ListViewID, edx
		mov	ecx, (NM_LISTVIEW ptr [eax]).iItem
		mov	lvitem.iItem, ecx
		mov	lvitem.iSubItem, 0
		mov	lvitem.imask, LVIF_STATE
		mov	lvitem.stateMask, 3
		lea	eax, lvitem
		push	eax
		push	0
		push	LVM_GETITEM
		push	edx
		push	hDlg
		call	SendDlgItemMessage
		; -------------------------------
		; Is selected this item?
		; -------------------------------
		mov	eax, lvitem.state
		cmp	eax, 3
		jne	o5
		; ------------------------------------------------
		; The item has been selected. Create a popup menu
		; ------------------------------------------------
		call	CreatePopupMenu
		.if eax!=0
		  ; -----------------------------------------------------
		  ; If the menu was created, add the item text
		  ; -----------------------------------------------------
			xor	ebx, ebx
			mov	edi, 205

			push	offset szStrClose
			push	edi
			push	ebx
			push	eax

			push	offset szStrHelp
			dec	edi
			push	edi
			push	ebx
			push	eax

			mov	esi, ebx
			push	ebx
			dec	ebx
			push	ebx
			push	MF_SEPARATOR
			push	eax

			push	offset szStrPEInfo
			dec	edi
			push	edi
			push	esi
			push	eax

			push	offset szStrPartialDump
			dec	edi
			push	edi
			push	esi
			push	eax

			push	offset szStrRefresh
			dec	edi
			push	edi
			push	esi
			push	eax

			push	offset szStrTerminate
			dec	edi
			push	edi
			push	esi
			push	eax
			mov	esi, eax

			mov	edi, AppendMenu
			mov	ebx, 7
@q001:			call	edi
			dec	ebx
			jne	@q001
	  ; ------------------------
	  ; Get the cursor position
	  ; ------------------------
			invoke	GetCursorPos, addr pt
	  ; -----------------
	  ; Initializehe menu
	  ; -----------------
		  	invoke	TrackPopupMenu, esi, TPM_LEFTALIGN or TPM_RIGHTBUTTON,\ 
                               		pt.x, pt.y, 0, hDlg, NULL 
	  ; --------------
	  ; Kill the menu
	  ; --------------
		  	invoke	DestroyMenu, esi
			invoke	DestroyMenu, hMenu          
		.endif

	.elseif	cx==LVN_ITEMCHANGED
		mov	ecx, (NM_LISTVIEW ptr [eax]).uNewState
		mov	edx, (NM_LISTVIEW ptr [eax]).hdr.idFrom
		.if ecx==3 && edx==100
		; ----------------------
		; Get the selected item
		; ----------------------
			mov	ecx, (NM_LISTVIEW ptr [eax]).iItem
			mov	lvitem.iItem, ecx
			mov	lvitem.iSubItem, 1
			mov	lvitem.imask, LVIF_TEXT
			lea	edi, buffer
		; ---------------
		; Get the IDP
		; ---------------
			call	ZeroBuffer
			mov	lvitem.pszText, edi
			mov	lvitem.cchTextMax, 9
			lea	eax, lvitem
			push	eax
			push	0
			push	LVM_GETITEM
			push	100
			push	hDlg
			call	SendDlgItemMessage
			push	offset temp_dword
			push	edi
			call	ascii2dword
		; -------------------------
		; Get the first module
		; -------------------------
			push	eax
			push	TH32CS_SNAPMODULE
			call	CreateToolhelp32Snapshot
			cmp	eax, -1
			je	o5
			mov	hSnapshot, eax
			mov	me32.dwSize, sizeof me32
        		lea	esi, me32
        		mov	dword ptr [esi], sizeof MODULEENTRY32
        		invoke	Module32First, eax, esi
        		or	eax, eax
			jne	s11
			invoke  SendDlgItemMessage, hDlg, 101, LVM_DELETEALLITEMS, eax, eax
			jmp	r11
		; ------------------------------
		; To fill the LV_ITEM structure
		; ------------------------------
s11:			mov	lvitem.imask, LVIF_TEXT
			mov	lvitem.iItem, 0
		; ------------------------------
		; Clean the listview control
		; ------------------------------
			push	101
			push	[ebp+8]
			call	GetDlgItem
			push	0
			push	0
			push	LVM_DELETEALLITEMS
			push	eax
			call	SendMessage
		; ------------------------
		; Insert first item
		; ------------------------
r10:			lea	esi, me32.szModule
			lea	edi, buffer
			call	ZeroBuffer
			invoke	lstrlen, esi
			inc	eax
			invoke	lstrcpyn, edi, esi, eax
			mov	lvitem.pszText, edi

			push	101
			push	hDlg
			call	GetDlgItem
			mov	esi, lvitem.iItem
			mov	ecx, 4
			mov	edx, LVM_SETITEM
			lea	ebx, lvitem

b12:			push	ebx
			push	esi
			push	edx
			push	eax
			dec	ecx		
			jne	b12

			mov	edx, LVM_INSERTITEM
			push	ebx
			push	esi
			push	edx
			push	eax
			mov	lvitem.iSubItem, 0
			mov	ebx, SendMessage
			call	ebx
		; ------------------------------
		; Insert next items
		; ------------------------------
			inc	lvitem.iSubItem
			call	ZeroBuffer
			invoke	wsprintf, edi, addr template, me32.th32ProcessID
			call	ebx

			inc	lvitem.iSubItem
			call	ZeroBuffer
			invoke	wsprintf, edi, addr template, me32.th32ModuleID
			call	ebx

			inc	lvitem.iSubItem
			call	ZeroBuffer
			invoke	wsprintf, edi, addr template, me32.modBaseAddr
			call	ebx

			inc	lvitem.iSubItem
			call	ZeroBuffer
			invoke	wsprintf, edi, addr template, me32.modBaseSize
			call	ebx
	; -----------------------------
	; Get the next process
	; -----------------------------
			push	me32.th32ProcessID
   			invoke	Module32Next, hSnapshot, addr me32
			pop	ecx
			test	eax, eax
			je	r11
			cmp	ecx, me32.th32ProcessID
			jne	r11
			inc	lvitem.iItem
			jmp	r10
	; --------------------------------------------------
	; Close handle of the snapshot
	; --------------------------------------------------
r11:			invoke	CloseHandle, hSnapshot
		.endif
	.endif
	jmp	o5

; **************************** WM_COMMAND *******************************
	
o2:  	cmp eax, WM_COMMAND
	jne o3
	mov eax,wParam
	.if ax==200
; ===============
; Kill a process
; ===============
	; ----------------------------------
	; get the process ID from this item
	; ----------------------------------
		invoke	SendDlgItemMessage, hDlg, 100, LVM_GETNEXTITEM, -1, LVNI_ALL or LVNI_SELECTED
		mov	lvitem.iItem, eax
		mov	lvitem.imask, LVIF_TEXT
		lea	edi, buffer
		invoke	RtlZeroMemory, edi, 256
		mov	lvitem.pszText, edi
		mov	lvitem.cchTextMax, 9
		mov	lvitem.iSubItem,1
		invoke	SendDlgItemMessage, hDlg, 100, LVM_GETITEM, 0, addr lvitem
		invoke	ascii2dword, edi, addr ProcessID
	; ---------------------------------
	; get the process handle
	; ---------------------------------
		invoke	OpenProcess, PROCESS_ALL_ACCESS, 0, ProcessID
		mov	hProcess, eax
; ----------------------
; Terminate the process
; ----------------------
		invoke	GetExitCodeProcess, hProcess, addr uCode
		invoke	TerminateProcess, hProcess, uCode
		invoke	CloseHandle, eax
		invoke	SendMessage, hDlg, WM_INITDIALOG, 0, 700

	.elseif ax==201
; =================
; Refresh the list
; =================
		invoke	SendMessage, hDlg, WM_INITDIALOG, 0, 700

	.elseif ax==202
; ================
; Partial dump 
; ================
	; ----------------------------------------
	; get the process ID from this item
	; ----------------------------------------
		invoke	SendDlgItemMessage, hDlg, 100, LVM_GETNEXTITEM, -1, LVNI_ALL or LVNI_SELECTED
		mov	lvitem.iItem, eax
		mov	lvitem.imask, LVIF_TEXT
		lea	edi, buffer
		invoke	RtlZeroMemory, edi, 256
		mov	lvitem.pszText, edi
		mov	lvitem.cchTextMax, 9
		mov	lvitem.iSubItem,1
		invoke	SendDlgItemMessage, hDlg, 100, LVM_GETITEM, 0, addr lvitem
		invoke	lstrcpy, addr buff2, edi
	; ---------------------------------------------
	; get the module name from this item
	; ---------------------------------------------
		invoke	RtlZeroMemory, edi, 256
		mov	lvitem.cchTextMax, 256
		mov	lvitem.iSubItem, 0
		invoke	SendDlgItemMessage, hDlg, 100, LVM_GETITEM, 0, addr lvitem

		push	hDlg
		call	IsPartialDump

	.elseif ax==203
; ================================
; Display sections info
; ================================
	; ----------------------------------------
	; get the process ID from this item
	; ----------------------------------------
		invoke	SendDlgItemMessage, hDlg, 100, LVM_GETNEXTITEM, -1, LVNI_ALL or LVNI_SELECTED
		mov	lvitem.iItem, eax
		mov	lvitem.imask, LVIF_TEXT
		lea	edi, buffer
		call	ZeroBuffer
		mov	lvitem.pszText, edi
		mov	lvitem.cchTextMax, 9
		mov	lvitem.iSubItem,1
		invoke	SendDlgItemMessage, hDlg, 100, LVM_GETITEM, 0, addr lvitem
		invoke	ascii2dword, edi, addr ProcessID
	; ------------------------------------------
	; get the base addres from this process
	; ------------------------------------------
		; ---------------------------------------------
		; get the module name from this item
		; ---------------------------------------------
		call	ZeroBuffer
		mov	lvitem.cchTextMax, 256
		mov	lvitem.iSubItem, 0
		invoke	SendDlgItemMessage, hDlg, 100, LVM_GETITEM, 0, addr lvitem
		; --------------------
		; get the module base
		; --------------------
		invoke	GetBaseAddressFromPID, ProcessID
		or	eax, eax
		jne	_going

		push	30h
		push	offset titulo
		push	offset msg_71
		push	[ebp+8]
		call	MessageBox
		jmp	o5

_going:		mov	esi, eax
		mov	ImageBase, eax
		invoke	OpenProcess, PROCESS_ALL_ACCESS, 0, ProcessID
		mov	hProcess, eax
		; -------------------
		; Is a pe file? 
		; -------------------
		push	esi
		add	esi, 03Ch              
		lea	edi, i
		invoke	ReadProcessMemory, hProcess, esi, edi, 4, addr temp_dword
		pop	esi
		add	esi, i
		invoke	ReadProcessMemory, hProcess, esi, edi, 4, addr temp_dword
                mov	eax, i
		cmp	ax, 'EP'
		je	is_pe2
		invoke	MessageBox, 0, addr msg_70, addr CaptionStr, 30h
                invoke	CloseHandle, hProcess
		jmp	o5
		; -------------------------------
		; Get number of sections
		; -------------------------------
is_pe2:		push   esi
		add    esi, 6      
		lea    edx, NumberOfSections
		invoke ReadProcessMemory, hProcess, esi, edx, 2, addr temp_dword
		; -----------------------------------
		; Get sections header
		; -----------------------------------
		pop    esi
		add    esi, sizeof IMAGE_FILE_HEADER + sizeof IMAGE_OPTIONAL_HEADER + 4
		mov    pSectHeader, esi
		mov    ax, NumberOfSections
		mov    ecx, 28h
		mul    ecx
		mov    SectHeaderSize, eax
		push   eax
		invoke VirtualAlloc, 0, eax, MEM_COMMIT, PAGE_READWRITE
		mov    edi, eax
		mov    pMem, eax
		pop    eax
		invoke ReadProcessMemory, hProcess, esi, edi, eax, addr temp_dword
		mov    esi, edi

		push   hDlg
		pop    temp_dword

		push   esi
		push   offset SectInfoProc
		push   hDlg
		push   1002
		push   hInst
		Call   DialogBoxParamA

                invoke CloseHandle, hProcess
		invoke VirtualFree, esi, 0, MEM_RELEASE
		jmp o5
y4:
      .elseif ax==3001
; ================ 
; Load process
; =================
             	push	hDlg
              	pop	hMainWnd
	; -------------------------
	; Load it from other thread
	; -------------------------
              	xor	eax, eax
              	push	offset temp_dword
              	push	eax
              	push	eax
              	push	offset create_proc
              	push	eax
	      	push	eax
	      	call	CreateThread
		push	eax
		call	CloseHandle

	.elseif ax==204
; =================
; Display the help
; =================
	        push	offset HelpPs
	        push	HELP_KEY
	        push	offset HelpFile
		push	hDlg
		call	WinHelp

	.elseif ax==205
; =====================
; Close the dialog box
; =====================
		jmp	_Close_

	.elseif ax==IDCANCEL
		jmp	_Close_

	.endif

	jmp	o5

; **************************** WM_CLOSE *******************************
		
o3:	cmp	eax, WM_CLOSE
	jne	o4
_Close_:
	invoke	EndDialog, hDlg, 0
	jmp	o5

; **************************** return false*****************************

o4:	xor	eax,eax
	ret

; **************************** return true *****************************

o5:	xor	eax,eax
	inc	al
        ret

o40:    mov	flg_0, 1
        jmp	o4

DlgProc endp

; :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

create_proc:
; ----------------------------------
; To fill OPENFILENAME struct
; ----------------------------------
 	push	offset FilterStr1 ;  ->"Modules ( *.exe, *.dll, *.ocx)"
	pop	ofn.lpstrFilter
	lea	edi, buffer
	Call	ZeroBuffer
	mov	ofn.lpstrFile, edi
; -----------------------
; Selecct a program
; -----------------------
	push	offset ofn
	call	GetOpenFileName
	or	eax, eax
	je	l0
; -----------------------
; Initialize the process
; -----------------------
	; --------------------------------
	; Fill the STARTUPINFO strucuture 
	; --------------------------------
	lea	esi, pinfo
	push	esi
	lea	esi, sui
	push	esi
	call	GetStartupInfo
	mov	sui.dwFlags, STARTF_USESHOWWINDOW
	mov	sui.wShowWindow, SW_SHOWMINIMIZED
	; ------------------
	; Load the process
	; ------------------
	xor	eax, eax
	push	esi
	push	eax
	push	eax
	push	NORMAL_PRIORITY_CLASS
	push	eax
	push	eax
	push	eax
	push	edi
	push	eax
	call	CreateProcess
	or	eax, eax
	jne	l0
	; --------------------------
	; Something is bad: advise
	; --------------------------
	push	30h
	push	offset titulo
	push	offset msg_72
	push	0
	call	MessageBox
	xor	eax, eax
	ret
	; --------------------------
	; Refresh the main listview
	; --------------------------
l0:     push	700
	push	0
	push	WM_INITDIALOG
	push	hMainWnd
	call	SendMessage

	push	hMainWnd
	call	BringWindowToTop
	xor	eax, eax
	inc	al
	ret

; :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

GetBaseAddressFromPID proc uses ebx esi edi PID:DWORD
local me32:MODULEENTRY32
	invoke	CreateToolhelp32Snapshot, TH32CS_SNAPMODULE, PID
	or	eax, eax
	je	@fail
	mov	me32.dwSize, sizeof me32
	lea	esi, me32
	mov	ebx, eax
      	invoke	Module32First, eax, esi
	or	eax, eax
	je	@fail
	mov	eax, me32.th32ProcessID
	mov	edi, PID
	.while eax!=edi
		invoke	Module32Next, ebx, esi
		or	eax, eax
		je	@fail
		mov	eax, me32.th32ProcessID
	.endw
	push	me32.modBaseAddr
	invoke	CloseHandle, ebx
	pop	eax
@fail:	ret
GetBaseAddressFromPID endp


; :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

RefreshListview	proc	uses esi edi ebx hDlg:DWORD, Param:DWORD

; --------------------------------------------------------------------------

local lppe:PROCESSENTRY32, hSnapshot:DWORD, hListView:DWORD
local lvcolumn:LV_COLUMN, lvitem:LV_ITEM, me32:MODULEENTRY32, i:DWORD

; --------------------------------------------------------------------------

	mov	ebx, hDlg
; -----------------------------
; Clean the list view control
; -----------------------------
	invoke	SendDlgItemMessage, ebx, 100, LVM_DELETEALLITEMS, 0, 0
	invoke	SendDlgItemMessage, ebx, 101, LVM_DELETEALLITEMS, 0, 0
; -------------------------------------------
; Get the ListView control handle
; -------------------------------------------
	invoke	GetDlgItem, ebx, 100
	mov	hListView, eax
	.if Param==0
		mov	lvcolumn.imask, LVCF_FMT+LVCF_SUBITEM+LVCF_TEXT+LVCF_WIDTH
		mov	lvcolumn.fmt, LVCFMT_CENTER

		mov	esi, eax
		lea	edi, lvcolumn
		mov	ebx, LVM_INSERTCOLUMN
		mov	eax, 3
		mov	ecx, 4

b0:		push	edi
		push	eax
		push	ebx
		push	esi
		dec	eax
		dec	ecx
		jne	b0

		mov	ebx, SendMessage

		mov	lvcolumn.lx, 232
		mov	lvcolumn.pszText, offset Col1
		call	ebx

		mov	lvcolumn.lx, 72
		mov	lvcolumn.pszText, offset Col2
		call	ebx

		mov	lvcolumn.pszText, offset Col3
		call	ebx

		mov	lvcolumn.pszText, offset Col5
		call	ebx

      		invoke	GetDlgItem, hDlg, 101
		mov	ebx, LVM_INSERTCOLUMN
		mov	edx, 4
		mov	ecx, 5

b1:		push	edi
		push	edx
		push	ebx
		push	eax
		dec	edx
		dec	ecx
		jne	b1

		mov	ebx, SendMessage

		mov	lvcolumn.lx, 140
		mov	lvcolumn.pszText, offset Col6
		call	ebx

		mov	lvcolumn.lx, 80
		mov	lvcolumn.pszText, offset Col2
		call	ebx

		mov	lvcolumn.pszText, offset Col3
		call	ebx

		mov	lvcolumn.pszText, offset Col7
		call	ebx

		mov	lvcolumn.pszText, offset Col8
		call	ebx
	.endif
; ------------------------------
; Add items to listview control
; -----------------------------
	; -----------------------------------------------
	; Get the active process info 
	; -----------------------------------------------
		; ---------------
		; First process
		; ---------------
p2:		mov	i, 0
		invoke	CreateToolhelp32Snapshot, TH32CS_SNAPPROCESS, 0
		mov	hSnapshot, eax
		lea	ecx, lppe
		mov	dword ptr [ecx], sizeof lppe
op3:		invoke	Process32First, eax, ecx
		test	eax,eax
		je	r1
		mov	lvitem.imask, LVIF_TEXT
		mov	lvitem.iItem, 0
		; ------------------------
		; Insert first item
		; ------------------------
r0:		lea	esi, lppe.szExeFile
		lea	edi, buffer
		call	ZeroBuffer
		invoke	lstrlen, esi
		inc	eax
		invoke	lstrcpyn, edi, esi, eax
		mov	lvitem.pszText, edi

		mov	esi, lvitem.iItem
		mov	ecx, 3
		mov	edx, LVM_SETITEM
		lea	eax, lvitem
		mov	ebx, hListView
		
b2:		push	eax
		push	esi
		push	edx
		push	ebx
		dec	ecx		
		jne	b2

		mov	edx, LVM_INSERTITEM
		push	eax
		push	esi
		push	edx
		push	ebx
		lea	edi, buffer
		mov	lvitem.iSubItem, 0
		mov	ebx, SendMessage
		call	ebx
		; ------------------------------
		; Insert next items
		; ------------------------------
		inc	lvitem.iSubItem
		call	ZeroBuffer
		invoke	wsprintf, edi, addr template, lppe.th32ProcessID
		call	ebx

		inc	lvitem.iSubItem
		call	ZeroBuffer
		invoke	wsprintf, edi, addr template, lppe.th32ModuleID
		call	ebx

		inc	lvitem.iSubItem
		call	ZeroBuffer
		invoke	wsprintf, edi, addr template, lppe.th32ParentProcessID
		call	ebx
	; -----------------------------
	; Get the next process
	; -----------------------------
		invoke	Process32Next, hSnapshot, addr lppe
		test	eax,eax
		je	r1
		inc	lvitem.iItem
		jmp	r0
	; --------------------------------------------------
	; If is refresh, close handle of the snapshot
	; --------------------------------------------------
r1:		invoke	CloseHandle, hSnapshot
		ret
RefreshListview	endp

; :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

include PartialDump.asm
include SectInf.asm
include general.asm

; :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

end entry

; :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

